/*
Copyright (c) 1993, Clemens Wagner
 
Permission to use, copy, modify, and distribute this software and 
its documentation for any purpose is hereby granted without fee, provided
that
(i) you have alays to distribute the whole archive
(ii) the above copyright notices and this permission notice appear in
all copies of the software and related documentation, changed or new
code has to be marked
(iii) else, there are the same conditions as for InterViews

THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 */

#ifndef COLORTAB_H
#define COLORTAB_H

#include <InterViews/color.h>

class ColorList;
class String;

class ColorDictionary: public Resource
{
	public:
		ColorDictionary();
		virtual ~ColorDictionary();

		/* should never return nil */
		static const Color *color
		(
			ColorIntensity r,ColorIntensity g,ColorIntensity b,float alpha=1.0,
			const char *name=""
		);

		/* for (symbolic) Colornames, like 'seagreen' or 'NodeFgColor' */
		/* could return nil */
		static const Color *color(const char *);
		static const Color *color(const String &);
	protected:
	private:
		static const Color *find(const char *);
		static const Color *find(const Color &);
		static ColorList *_colors;
		static long _ref;
};

#endif
