/*
Copyright (c) 1993, Clemens Wagner
 
Permission to use, copy, modify, and distribute this software and 
its documentation for any purpose is hereby granted without fee, provided
that
(i) you have alays to distribute the whole archive
(ii) the above copyright notices and this permission notice appear in
all copies of the software and related documentation, changed or new
code has to be marked
(iii) else, there are the same conditions as for InterViews

THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 */

#ifndef GRAPHIC_COMMAND_H
#define GRAPHIC_COMMAND_H

#include "classes.h"

#include <InterViews/action.h>
#include <InterViews/coord.h>

class GraphicMaster;

class Command: public Resource
{
	public:
		virtual ~Command();

		virtual void execute();

		GraphicMaster *graphic_master() const; // inline

		virtual ClassId get_classid() const;
		virtual boolean is_a(ClassId) const;
	protected:
		Command(GraphicMaster *);
	private:
		GraphicMaster *_graphic_master;
};

inline GraphicMaster *Command::graphic_master() const
{
	return _graphic_master;
}

class CommandAction: public Action
{
	public:
		CommandAction(Command *);
		virtual ~CommandAction();

		virtual void execute();
	private:
		Command *_cmd;
};

#endif
