/*
Copyright (c) 1993, Clemens Wagner
 
Permission to use, copy, modify, and distribute this software and 
its documentation for any purpose is hereby granted without fee, provided
that
(i) you have alays to distribute the whole archive
(ii) the above copyright notices and this permission notice appear in
all copies of the software and related documentation, changed or new
code has to be marked
(iii) else, there are the same conditions as for InterViews

THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 */

#ifndef GRAPHIC_HANDLES_H
#define GRAPHIC_HANDLES_H

#include <InterViews/coord.h>

class BoxObj;
class Canvas;

class Handles
{
	public:
		Handles(const Coord *,const Coord *,int,Canvas * =nil);
		virtual ~Handles();

		void draw(Canvas * =nil);
		void redraw();
		void erase();
		void getbounds(Coord &,Coord &,Coord &,Coord &);
		boolean drawn();
		static Coord tol();

		int get_original(Coord *&,Coord *&);
	protected:
		Canvas *_canvas;
		Coord *_x,*_y;
		boolean _drawn;
		int _nhandles;
};

inline boolean Handles::drawn()
{
	return _drawn;
}

inline int Handles::get_original(Coord *&x,Coord *&y)
{
	x=_x;
	y=_y;
	return _nhandles;
}

#endif
