/*
Copyright (c) 1993, Clemens Wagner
 
Permission to use, copy, modify, and distribute this software and 
its documentation for any purpose is hereby granted without fee, provided
that
(i) you have alays to distribute the whole archive
(ii) the above copyright notices and this permission notice appear in
all copies of the software and related documentation, changed or new
code has to be marked
(iii) else, there are the same conditions as for InterViews

THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 */

#ifndef GRAPHIC_MENUTOOL_H
#define GRAPHIC_MENUTOOL_H

#include "tool.h"

class Dialog;
class Graphic;
class Line;
class Menu;
class PopupWindow;
class SlidingLine;
class SlidingRect;
class Window;

class ToolMenu: public Resource
{
	public:
		virtual ~ToolMenu();

		virtual Menu *menu();

		void target(Graphic *);
		Graphic *target();

		static void main_window(Window *); // inline
		static Window *main_window(); // inline
	protected:
		ToolMenu(Menu *);
	private:
		Graphic *_target;
		Menu *_menu;
		static Window *_window;
};

inline void ToolMenu::main_window(Window *w)
{
	_window=w;
}

inline Window *ToolMenu::main_window()
{
	return _window;
}

inline Menu *ToolMenu::menu()
{
	return _menu;
}

inline void ToolMenu::target(Graphic *g)
{
	_target=g;
}

inline Graphic *ToolMenu::target()
{
	return _target;
}

class MenuTool: public Tool
{
	public:
		MenuTool(GraphicMaster *,ToolMenu *);
		virtual ~MenuTool();

		virtual boolean grasp(const Event &);
		virtual boolean manipulating(const Event &);
		virtual boolean effect(const Event &);

		virtual ClassId get_classid() const;
		virtual boolean is_a(ClassId) const;
	protected:
	private:
		ToolMenu *_menu;
		PopupWindow *_popup;
};

#endif
